comment #
 MakeLink.asm
  ActiveX simple client to demonstrate basic concepts
  written & (c) copyright April 5, 2000 by Ernest Murphy
  contact the author at ernie@surfree.com
  may be reused for any educational or
  non-commercial application without further license
#
.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\ole32.inc
include \masm32\com\include\oaidl.inc
 ;coinvoke macro
include \masm32\com\include\shlobj.inc
 ;IShellLink struct
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\ole32.lib
CoCreateLink proto:dword,:dword
MakeMessage macro Text:req
 ;macro to display a message box
 ;the text to display is kept local to
 ;this routine for ease of use
 local lbl
 local sztext
 jmp lbl
 sztext:
 db Text,0
 lbl:
 invoke MessageBox,NULL,sztext,addr szAppName,MB_OK
endm
IPersistFile struct dword
 ;IPersistFile Interface
 IPersistFile_QueryInterface comethod3 ?
 IPersistFile_AddRef comethod1 ?
 IPersistFile_Release comethod1 ?
 IPersistFile_GetClassID comethod2 ?
 IPersistFile_IsDirty comethod1 ?
 IPersistFile_Load comethod3 ?
 IPersistFile_Save comethod3 ?
 IPersistFile_SaveCompleted comethod2 ?
 IPersistFile_GetCurFile comethod2 ?
IPersistFile ends
.data
 szAppName byte "Shell Link Maker",0
 szLinkName byte "Shortcut to MakeLink.lnk",0
 szBKSlash byte "\",0
 hInstance HINSTANCE ?
 Pos dword ?
 szBuffer1 byte MAX_PATH dup(?)
 szBuffer2 byte MAX_PATH dup(?)
.code
 start:
 invoke GetModuleHandle,NULL
  ;00401000
   ;push 0
   ;call <jmp.&kernel32.GetModuleHandleA>
  ;this bracketed code is just a 'quick hack'
  ;to replace the filename from the filepathname
  ;with the 'Shortcut to' title
 mov hInstance,eax
 invoke GetModuleFileName,NULL,addr szBuffer1,MAX_PATH
 invoke lstrcpy,addr szBuffer2,addr szBuffer1
 ;Find the last backslash '\' and change it to zero
 mov edx,offset szBuffer2
 mov ecx,edx
 .repeat
  mov al,byte ptr[edx]
  .if al==92
   ;"\"
   mov ecx,edx
  .endif
  inc edx
 .until al==0
 mov byte ptr[ecx+1],0
 invoke lstrcpy,addr szBuffer2,addr szLinkName
 invoke CoInitialize,NULL
  ;here is where we call the proc with the COM methods
 MakeMessage "Let's try our Createlink."
  ;0040105A
   ;jmp short 00401076
   ;db "Let's try our Createlink.",0
   ;push 0
   ;push 00403000
   ;push 0040105C
   ;push 0
   ;call <jmp.&user32.MessageBoxA>
 invoke CoCreateLink,addr szBuffer1,addr szBuffer2
  ;00401089
   ;push 00403138
   ;push 00403034
   ;call 004010CE
 MakeMessage "That's all folks !!!"
 invoke CoUninitialize
 invoke ExitProcess,NULL
 CoCreateLink proc pszPathObj:dword,pszPathLink:dword
  local pwsz:dword
  local psl:dword
  local ppf:dword
  local hResult:dword
  local hHeap:dword
   ;CreateLink - uses the shell's IShellLink and IPersistFile interfaces
   ;to create and store a shortcut to the specified object.
   ;Returns the hresult of calling the member functions of the interfaces.
   ;pszPathObj - address of a buffer containing the path of the object.
   ;pszPathLink - address of a buffer containing the path where the
   ;shell link is to be stored.
   ;addapted from MSDN article "Shell Links"
   ;deleted useless "description" method
   ;added set icon location method
   ;004010CE
    ;push ebp
    ;mov ebp,esp
    ;add esp,-14
  .data
   CLSID_ShellLink GUID sCLSID_ShellLink
    ;sCLSID_ShellLink textequ
    ;\masm32\com\include\shlobj.inc
   IID_IShellLink GUID sIID_IShellLink
    ;sIID_IShellLink textequ
    ;\masm32\com\include\shlobj.inc
   IID_IPersistFile GUID {00000010Bh,00000h,00000h,{0C0h,000h,000h,000h,000h,000h,000h,046h}}
  .code
   invoke GetProcessHeap
    ;004010D4
     ;call <jmp.&kernel32.GetProcessHeap>
    ;first, get some heap for a wide buffer
   mov hHeap,eax
   invoke HeapAlloc,hHeap,NULL,MAX_PATH*2
   mov pwsz,eax
   invoke CoCreateInstance,addr CLSID_ShellLink,NULL,CLSCTX_INPROC_SERVER,addr IID_IShellLink,addr psl
    ;004010EE
     ;lea eax,dword ptr ss:[ebp-8]
     ;push eax
      ;address of local variable
     ;push 0040324C
     ;push 1
     ;push 0
     ;push 0040323C
     ;call <jmp.&ole32.CoCreateInstance>
    ;Get a pointer to the IShellLink interface.
    ;http://msdn.microsoft.com/en-us/library/ms686615.aspx
     ;MSDN -> MSDN Library -> Win32 and COM Development -> Component Development -> COM -> Component Object Model (COM) -> COM Fundamentals -> Reference -> Functions -> CoCreateInstance Function
      ;CoCreateInstance Function
       ;Creates a single uninitialized object of the class associated with a specified CLSID.
       ;Call CoCreateInstance when you want to create only one object on the local system. To create a single object on a remote system, call the CoCreateInstanceEx function. To create multiple objects based on a single CLSID, call the CoGetClassObject function.
       ;Syntax
        ;C++
         ;HRESULT CoCreateInstance
          ;(
           ;__in REFCLSID rclsid,
           ;__in LPUNKNOWN pUnkOuter,
           ;__in DWORD dwClsContext,
           ;__in REFIID riid,
           ;__out LPVOID *ppv
          ;);
       ;Parameters
        ;rclsid [in]
         ;The CLSID associated with the data and code that will be used to create the object.
        ;pUnkOuter [in]
         ;If NULL, indicates that the object is not being created as part of an aggregate. If non-NULL, pointer to the aggregate object's IUnknown interface (the controlling IUnknown).
        ;dwClsContext [in]
         ;Context in which the code that manages the newly created object will run. The values are taken from the enumeration CLSCTX.
        ;riid [in]
         ;A reference to the identifier of the interface to be used to communicate with the object.
        ;ppv [out]
         ;Address of pointer variable that receives the interface pointer requested in riid. Upon successful return, *ppv contains the requested interface pointer. Upon failure, *ppv contains NULL.
       ;Return Value
        ;This function can return the following values.
         ;S_OK
          ;An instance of the specified object class was successfully created.
         ;REGDB_E_CLASSNOTREG
          ;A specified class is not registered in the registration database. Also can indicate that the type of server you requested in the CLSCTX enumeration is not registered or the values for the server types in the registry are corrupt.
         ;CLASS_E_NOAGGREGATION
          ;This class cannot be created as part of an aggregate.
         ;E_NOINTERFACE
          ;The specified class does not implement the requested interface, or the controlling IUnknown does not expose the requested interface.
         ;E_POINTER
          ;The ppv parameter is NULL.
   mov hResult,eax
   test eax,eax
   .if SUCCEEDED
    ;0040110A
     ;js 00401193
    coinvoke psl,IShellLink,QueryInterface,addr IID_IPersistFile,addr ppf
     ;00401110
      ;mov edx,dword ptr ss:[ebp-8]
      ;mov edx,dword ptr ds:[edx]
      ;lea eax,dword ptr ss:[ebp-C]
      ;push eax
      ;push 0040325C
      ;push dword ptr ss:[ebp-8]
      ;call dword ptr ds:[edx]
     ;Query IShellLink for the IPersistFile
     ;interface for saving the shortcut
     ;\masm32\com\include\oaidl.inc
     ;QueryInterface
      ;\masm32\com\include\oaidl.inc
       ;_vtIUnknown macro
    mov hResult,eax
    test eax,eax
    .if SUCCEEDED
     ;00401128
      ;js short 00401194
     coinvoke psl,IShellLink,SetPath,pszPathObj
      ;0040112A
      ;Set the path to the shortcut target
     mov hResult,eax
     coinvoke psl,IShellLink,SetIconLocation,pszPathObj,0
      ;0040113B
      ;add the description, use first icon found
     mov hResult,eax
     invoke MultiByteToWideChar,CP_ACP,0,pszPathLink,-1,pwsz,MAX_PATH
      ;0040114E
       ;push 104
       ;push dword ptr ss:[ebp-4]
       ;push -1
       ;push dword ptr ss:[ebp+C]
       ;push 0
       ;push 0
       ;call <jmp.&kernel32.MultiByteToWideChar>
      ;change string to Unicode.
      ;(COM typically expects Unicode strings)
     invoke MessageBoxW,NULL,pwsz,pwsz,MB_OK
     coinvoke ppf,IPersistFile,Save,pwsz,TRUE
      ;Save the link by calling IPersistFile::Save
     mov eax,hResult
     coinvoke ppf,IPersistFile,Release
      ;release the IPersistFile ppf pointer
     mov hResult,eax
    .endif
    coinvoke psl,IShellLink,Release
     ;release the IShellLink psl pointer
    mov hResult,eax
   .endif
   invoke HeapFree,hHeap,NULL,pwsz
    ;free our heap space
   mov eax,hResult
    ;since we reuse this variable over and over,
    ;it contains the last operations result
   ret
 CoCreateLink endp
end start