;-------------------------------------------------------------------------------
;  colibrary procedure Release 
;
; -------------------------------------------------------
; This procedure was written by Ernest Murphy    9/27/00
;
; Copyright (c) 9/28/00  Ernest Murphy
; For educational use only. Any commercial re-use only by written license
;
; -------------------------------------------------------
.NOLIST
.386
.model flat, stdcall  ; 32 bit memory model
option casemap :none  ; case sensitive

include     mini_win.inc	; 'just enough' of windows.inc (speeds build)
include     \masm32\include\oleaut32.inc
include     \masm32\COM\include\oaidl.inc

include \masm32\com\include\colib.inc

.code
;-------------------------------------------------------------------------------

Release PROC PUBLIC this_:DWORD
             
;-------------------------------------------------------------------------------
; implimentation of the delegated IUnknown::Release function
;
;  performs a delegated Release passes off the release to the contained pIUnkOuter
;
; EXAMPLE:
;   coinvoke ppv, IUnknown, Release
;
; Uses: eax, ecx, edx
;
;
;-------------------------------------------------------------------------------
    mov ecx, this_                                ; get object
    mov ecx, (ObjectEntry PTR[ecx]).m_pBase       ; walk to base data
    mov ecx, (ObjectData PTR[ecx]).m_pUnkOuter    ; walk to delegated IUnknown ptr
    coinvoke ecx, IUnknown, Release
    ret
Release ENDP
;-------------------------------------------------------------------------------

end
