;L.inc
 ;Macro to produce wide character strings
 ;revised 02/26/2001
 ;complete re-write to simplify
 ;also add a back the backslash char
;copyright (c) July 30, 2000 Ernest Murphy
;For educational use only. Any commercial re-use only by written license
;Special codes:
 ;\0
  ;trailing zero
 ;\|
  ;exclamation point '!'
 ;\n
  ;new line (13,10)
 ;\\
  ;single backslash '\'
wchar typedef word
L macro sText:req
 local str,chr,flag,cchr
 cchr textequ <>
 str textequ <>
 flag textequ <.>
 forc chr,<&sText>
  ifidn flag,<\>
   ;;IF flag == '\'  we're in control char mode
   ifidn <&chr>,<\>
    ;;'\\' makes a single backslash
    cchr textequ <"\">
     ;;just as in C
   endif
  ifidn <&chr>,<|>
   ;;a pipe gives '!'
   cchr textequ <"!!">
    ;;need 2 because of macro alias
  endif
  ifidn <&chr>,<n>
   ;;"n" gives a new line
   cchr textequ <13,10>
  endif
  ifidn <&chr>,<0>
   ;;an "0" (terminating zero)
   cchr textequ <0>
  endif
  flag textequ <.>
   else
    ;;ELSE, not in control mode
    ifidn <&chr>,<\>
     ;;if chr =='\', go to control mode
     flag textequ <\>
     cchr textequ <>
    else
     ;;else must be a regular char
     cchr catstr <">,<chr>,<">
    endif
   endif
   ifdif str,<>
    ;;need a comma before we add new
    ifdif flag,<\>
     str catstr str,<,>
    endif
   endif
   ifdif cchr,<>
    ;;check we don't add a blank
    str catstr str,&cchr
   endif
  endm
 exitm str
endm